#!/bin/sh
# $Id: musescore.SlackBuild,v 1.16 2025/01/20 20:46:11 root Exp root $
# Copyright 2019, 2020, 2021, 2022, 2025  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         musescore
# Descr:       music notation software
# URL:         https://musescore.org/
# Build needs: 
# Needs:       jack2
# Changelog:   
# 3.0.5-1:     12/mar/2019 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 3.1.0-1:     29/may/2019 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.2.0-1:     26/jun/2019 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.2.3-1:     09/jul/2019 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.3.0-1:     05/nov/2019 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.3.3-1:     27/nov/2019 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.3.4-1:     20/jan/2020 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.4.2-1:     11/mar/2020 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.5-1:       08/aug/2020 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.5.1-1:     10/oct/2020 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.5.2-1:     17/oct/2020 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.6.1-1:     30/jan/2021 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.6.2-1:     09/feb/2021 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.6.2-2:     18/sep/2022 by Eric Hameleers <alien@slackware.com>
#              * Rebuilt against PortMidi 2.0.3.
# 4.3.2-1:     05/jan/2025 by Eric Hameleers <alien@slackware.com>
#              * Update. This is the last release supporting Qt5.
# 4.3.2-2:     30/apr/2025 by Eric Hameleers <alien@slackware.com>
#              * Rebuilt against newer FLAC in -current.
# 
# Run 'sh musescore.SlackBuild' to build a Slackware package.
# The package (.t?z) and .txt file as well as build logs are created in /tmp .
# Install the package using 'installpkg' or 'upgradepkg --install-new'.
#
# -----------------------------------------------------------------------------

SRCNAM=MuseScore
PRGNAM=musescore
VERSION=${VERSION:-4.3.2}
MAJVER=$(echo $VERSION |cut -d. -f1,2)
BUILD=${BUILD:-2}
NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
TAG=${TAG:-alien}

DOCS="Compatibility LICENSE* README.md"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE[0]="$SRCDIR/${SRCNAM}-${VERSION}.tar.gz"
SRCURL[0]="https://github.com/${PRGNAM}/${SRCNAM}/archive/v${VERSION}.tar.gz"

SOURCE[1]="$SRCDIR/MuseScore_General.sf3"
SRCURL[1]="https://ftp.osuosl.org/pub/musescore/soundfont/MuseScore_General/MuseScore_General.sf3"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
  case "$(uname -m)" in
    i?86) ARCH=i586 ;;
    arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *) ARCH=$(uname -m) ;;
  esac
  export ARCH
fi
# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
case "$ARCH" in
  i?86)      SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS=${SLKCFLAGS:-"-O2"}
             SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
             ;;
esac

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  if ! [ -f ${SOURCE[$i]} ]; then
    echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
    # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
    [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
    if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
    if ! [ "x${SRCURL[$i]}" == "x" ]; then
      echo "Will download file to $(dirname $SOURCE[$i])"
      wget --no-check-certificate -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
      if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
        echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
        mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
        exit 1
      fi
    else
      echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
      exit 1
    fi
  fi
done

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar xf ${SOURCE[0]}
cd ${SRCNAM}-${VERSION}

# Add the soundfont:
install -D -m0644 ${SOURCE[1]} ./share/sound/

# Prevent an installation error:
sed -e 's/MuseScore_General-License.md/MuseScore_General_License.md/g' \
  -i share/sound/CMakeLists.txt

# Patches obtained from Fedora to deal with compilation errors:
touch $OUTPUT/patch-${PRGNAM}.log
cat $SRCDIR/patches/musescore_ffmpeg7.patch | patch -p1 --verbose \
    2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
cat $SRCDIR/patches/musescore_qeventloop.patch | patch -p1 --verbose \
    2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
cat $SRCDIR/patches/musescore_qmake-path.patch | patch -p1 --verbose \
    2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
cat $SRCDIR/patches/musescore_qtcore.patch | patch -p1 --verbose \
    2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
cat $SRCDIR/patches/musescore_qvariantmap.patch | patch -p1 --verbose \
    2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
cat $SRCDIR/patches/musescore_qvariantlist.patch | patch -p1 --verbose \
    2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
cat $SRCDIR/patches/musescore_qxmlstreamreader.patch | patch -p1 --verbose \
    2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log

chown -R root:root .
chmod -R u+w,go+r-w,a+rX-st .

echo Building ...
export LDFLAGS="$SLKLDFLAGS"
export CXXFLAGS="$SLKCFLAGS"
export CFLAGS="$SLKCFLAGS"

mkdir -p build-${PRGNAM}
pushd build-${PRGNAM}
  cmake .. \
    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
    -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_SKIP_RPATH=OFF \
    -DMUE_BUILD_CRASHPAD_CLIENT=OFF \
    -DMUE_BUILD_UNIT_TESTS=OFF \
    -DMUE_BUILD_VST_MODULE=OFF \
    -DMUE_COMPILE_USE_CCACHE=OFF \
    -DMUE_COMPILE_USE_PCH=OFF \
    -DMUE_COMPILE_USE_SYSTEM_FLAC=ON \
    -DMUE_COMPILE_USE_SYSTEM_FREETYPE=ON \
    -DMUE_COMPILE_USE_SYSTEM_OPUSENC=ON \
    -DMUE_DOWNLOAD_SOUNDFONT=OFF \
    -DMUE_ENABLE_AUDIO_JACK=ON \
    -DMUE_INSTALL_SOUNDFONT=OFF \
    -DMUSESCORE_BUILD_CONFIGURATION="app" \
    -DMUSESCORE_BUILD_MODE="release" \
    -DMUSESCORE_REVISION="22b46f2" \
    -DQT_INSTALL_DEMOS=/usr/doc/$PRGNAM-$VERSION/qtdemos \
    -DVST3_SDK_PATH=/usr/include/vst3sdk \
    -Wno-dev \
    2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
  make \
    2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
  make install DESTDIR=$PKG \
    2>&1 | tee $OUTPUT/install-${PRGNAM}.log
popd

# Add 'X-DAW' category to the desktop file (for liveslak):
for DESKTOPF in $PKG/usr/share/applications/*.desktop ; do
  if ! grep -q X-DAW $DESKTOPF ; then
    sed -i $DESKTOPF \
      -e "s/^Categories=\(.*\)/Categories=X-DAW;\1/"
  fi
done

# Un-bloat the desktop menu item's name:
sed -i $PKG/usr/share/applications/org.musescore.MuseScore.desktop \
  -e "s/^Name=.*$/Name=MuseScore/"

# Add this to the doinst.sh:
mkdir -p $PKG/install
cat <<EOINS >> $PKG/install/doinst.sh
# Update the desktop database:
if [ -x usr/bin/update-desktop-database ]; then
  chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
fi

# Update hicolor theme cache:
if [ -d usr/share/icons/hicolor ]; then
  if [ -x /usr/bin/gtk-update-icon-cache ]; then
    chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
  fi
fi

# Update the mime database:
if [ -x usr/bin/update-mime-database ]; then
  chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
fi

EOINS

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/slack-required > $PKG/usr/doc/$PRGNAM-$VERSION/slack-required
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Fix man page location:
mv $PKG/usr/share/man $PKG/usr/ || true

# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}

